function recaculate(){
    var docEl = document.documentElement;
    if(!docEl.clientWidth){return;}
    var docElFs = docEl.clientWidth/375*10 + 'px';
    docEl.style.fontSize = docElFs;
}
var resizeEvt = 'orientationchange' in window ? 'orientationchange' : 'resize';
window.addEventListener(resizeEvt, recaculate, false);

//Hybrid基本逻辑
(function () {
    window.Hybrid = window.Hybrid || {};
    window.Hybrid.ui = window.Hybrid.ui || {};
    Hybrid.callback = function (data) {
        var callbackId = data.callback;
        if(!callbackId) return;

        if(typeof data == 'string') data = JSON.parse(data);

        if(callbackId.indexOf('header_') != -1 && Hybrid['Header_Event']) {
            Hybrid['Header_Event'][callbackId] && Hybrid['Header_Event'][callbackId](data);
        } else {
            Hybrid[callbackId] && Hybrid[callbackId](data);
        }
        return true;
    };

    var bridgePostMsg = function (params) {
        var url = _getHybridUrl(params);

        //兼容ios6
        var iframe = document.createElement('iframe');
        iframe.style.cssText = 'display:none;width:0px;height:0px;';
        iframe.src = url;
        (document.body || document.documentElement).appendChild(iframe);
        setTimeout(function () {
            iframe && iframe.parentNode && iframe.parentNode.removeChild(iframe);
            iframe = null;
        }, 1000);

        return;
    };

    var _getHybridUrl = function (params) {
        var k, paramStr = '', url = 'kkhybrid://', flag = '?';
        url += params.tagname; //时间戳，防止url不起效

        if (params.callback) {
            flag = '&';
            url += '?callback=' + params.callback;
            //delete params.callback;
        }
        if (params.param) {
            paramStr = typeof params.param == 'object' ? JSON.stringify(params.param) : params.param;
            url += flag + 'param=' + encodeURIComponent(paramStr);
        }
        return url;
    };

    _setEvent = function (t, tmpFn) {
        window.Hybrid[t] = function (data) {
            tmpFn(data);
            delete window.Hybrid[t];
        };
    };

    //处理组件通信的情况
    var _handleMessage = function(events, tagname) {
        var tmpFn, data = {};
        var t;

        for(var key in events) {
            t = 'hybrid_' + tagname +  '_' + key;
            data[key] = t;
            tmpFn = events[key];
            _setEvent(t, tmpFn);
        }

        return data;
    };

    var requestHybrid = function (params) {
        if(!params.tagname) {
            alert('必须包含tagname');
        }
        //生成唯一执行函数，执行后销毁
        var tt = (new Date().getTime());
        var t = 'hybrid_' + params.tagname +  '_' + tt;
        // var t = 'hybrid_' + params.tagname;
        var tmpFn;

        //处理有回调的情况
        if (params.callback) {
            tmpFn = params.callback;
            params.callback = t;
            // console.log(t)
            window[t] = function (data) {
                tmpFn(data);
                delete window[t];
            }
            
        }

        bridgePostMsg(params);
    };

    var getHybridInfo = function () {
        var platform_version = {};
        var na = navigator.userAgent;
        na = na.toLowerCase();

        var info = na.match(/kkhybrid_\d\.\d\.\d/);

        if (info && info[0]) {
            info = info[0].split('_');
            if (info && info.length == 2) {
                platform_version.platform = info[0];
                platform_version.version = info[1];
            }
        }

        //*debug* 调试模拟环境
        if (_.getUrlParam().__platform) {
            platform_version.platform = _.getUrlParam().__platform;
            platform_version.version = _.getUrlParam().__version;
        }

        return platform_version;
    };

    var getVer = function () {
        var ver = getHybridInfo().version.replace(/\./g, '');
        if (ver) return parseInt(ver);
        return 0;
    };

    //版本在多少
    var versionAt = function (ver) {
        if (ver == getVer()) return true;
        return false;
    };

    var versionBefore = function (ver) {
        if (getVer() < ver) return true;
        return false;

    };

    var versionAfter = function (ver) {
        if (getVer() > ver) return true;
        return false;
    };

    var hybridCallback = function (opts) {
        //undefined, baidu_bus,
        var platform = _.getHybridInfo().platform || 'web';
        var mapping = {
            'web': '',
            'baidubox': 'bdbox_',
            'baidu_bus': 'bdbus_'
        };
        var callbackName = mapping[platform] || '';
        // 如果没有定义渠道callback 则默认为普通callback
        var callback = opts[callbackName + 'callback'] || opts['callback'];
        if (typeof callback == 'function') callback();
    };

    var registerHeaderCallback = function (ns, name, callback) {
        if (!window.Hybrid[ns]) window.Hybrid[ns] = {};
        window.Hybrid[ns][name] = callback;
    };

    var unRegisterHeaderCallback = function (ns) {
        if (!window.Hybrid[ns]) return;
        delete window.Hybrid[ns];
    };

    window.requestHybrid = requestHybrid;

})();

// loading toast
function loading(action, node, duration){
    var obj = {
        action: action, // show or hide
        node: node, // id or className
        duration: duration, // Unit is S, default is 2s
        // bgColor: 'transparent', 
    };
    var $node = document.querySelector(obj.node);                
    if(obj.action=='show'){
        $node.style.display = 'block';
        if($node.classList.contains('fadeout')){
            $node.classList.remove('fadeout');
        }
    } else if(obj.action=='hide'){                  
        if(obj.duration){
            setTimeout(function(){
                $node.style.display = 'none';
            }, obj.duration*1000);
        } else {
            setTimeout(function(){
                $node.classList.add('fadeout');
                setTimeout(function(){
                    $node.style.display = 'none';    
                }, 300);
            }, 0);
        }
    }
}

require.config({
    baseUrl: './',
    paths : {
        'vue': 'vue.min',
        'vueTap': 'vue-tap.min',
        'vueRes': 'vue-resource.min',
        'vueLazy': 'vue-lazyload',
        'storage': 'storage',
        'underscore': 'underscore'
    }
})


require(['storage','vue','vueLazy','vueTap','vueRes'],function(Storage,Vue,VueLazy,VueTap,VueRes){

    Vue.use(VueRes);
    Vue.use(VueTap);
    var Storage = new Storage();  
    var prod_host = 'http://www.kuaikanmanhua.com';
    var stag_host = 'http://staging.kuaikanmanhua.com';

var offline = new Vue({
    el: '.wrap-offline',
    data: {
        isOffline: false
    }
})
var rank = new Vue({
    el: '#rank-wrap',
    data: {
        rankType: '',
        rankLimit: 0,
        bannerImg: '',
        hasAnnounce: false,
        bgColor: '',
        nextTagType: '',
        nextTime: '',
        lists: [],
        comics_count: '',
        ruleColor: '',
        isOffline: false,
        haveCache: false,
        dataComplete: false
    },
    created: function(){
        recaculate();
    },
    mounted: function(){
        this.init();
    },
    methods: {
        init: function(){
            // 1：每周点击排行榜，2：新作榜，3：完结榜
            this.getlistData();
        },
        format: function(el){
            return el>9?el:'0'+el;
        },
        getlistData: function(){
            this.rankType = this.$refs.rank.value;
            var _this = this;
            var _thisRankType = this.rankType;
            // Storage.clear();
            var RANKCACHE = Storage.get('DATA_RANK_'+_thisRankType);
            
            switch(this.rankType){
                case '1':
                    this.rankLimit = 30;
                    this.bgColor = '#FFE43B';
                    this.nextTagType = 'orange';
                    this.ruleColor = '#773C19';
                break;
                case '2':
                    this.rankLimit = 20;
                    this.bgColor = '#91D3FF';
                    this.nextTagType = 'blue';
                    this.ruleColor = '#4B85AC';
                break;
                case '3':
                    this.rankLimit = 50;
                    this.bgColor = '#AEADFF';
                    this.nextTagType = '';
                    this.ruleColor = '#5554BA';
                break;
            }
            
            if(RANKCACHE){
                _this.bannerImg = RANKCACHE.banner_image_url;
                _this.lists = RANKCACHE.topics;
                _this.nextTime = RANKCACHE.next_update_date;
                _this.hasAnnounce = _this.nextTime?true:false;
                _this.haveCache = true;
                _this.dataComplete = true;
                loading('hide', '#loadingToast');
            }
            // network
            requestHybrid({
                tagname: 'sys',
                param: {
                    info: 'network' // 网络状态验证
                },
                callback: function(resp){
                    if(typeof resp == 'string') resp = JSON.parse(resp);
                    var data = resp['data'];
                    switch (data['network']) {
                        case -1://offline
                            if(RANKCACHE){
                                // 有缓存,渲染视图
                                _this.bannerImg = RANKCACHE.banner_image_url;
                                _this.lists = RANKCACHE.topics;
                                _this.nextTime = RANKCACHE.next_update_date;
                                _this.hasAnnounce = _this.nextTime?true:false;
                                _this.haveCache = true;
                                _this.dataComplete = true;

                            } else {
                                // 无缓存,显示网络差提示图
                                _this.isOffline = true; 
                                offline.isOffline = true;
                            }
                            loading('hide', '#loadingToast');
                        break;        
                        case 1://wifi
                        case 2://4g                    
                            var url = prod_host+'/v2/topic/rank_list/'+_thisRankType;
                            
                            if(!RANKCACHE){
                                Vue.use(VueLazy);
                            }
                            // 发起请求，获取 data
                            setTimeout(function(){

                            requestHybrid({
                                tagname: 'requestapi',
                                param: {
                                    url: url,
                                    type: 'get',
                                    dataTye: 'json',
                                    param: {
                                        since: 0,
                                        limit: _this.rankLimit
                                    }
                                },
                                callback: function(resp){
                                    function jsonEscape(str)  {
                                        return str.replace(/\n/g, "\\\\n").replace(/\r/g, "\\\\r").replace(/\t/g, "\\\\t");
                                    }
                                    resp = jsonEscape(resp);                  
                                    if(typeof resp == 'string') resp = JSON.parse(resp);
                                    var data = resp['data'];
                                    _this.bannerImg = data.banner_image_url;
                                    _this.lists = data.topics;
                                    _this.nextTime = data.next_update_date;
                                    _this.hasAnnounce = _this.nextTime?true:false;
                                    _this.dataComplete = true;
                                    
                                    //更新缓存
                                    Storage.set('DATA_RANK_'+_thisRankType, data)
                                    loading('hide', '#loadingToast');
                                }
                            });

                            },10);
                        break;
                        
                    }

                    
                }
            });

            
        },
        jumpto: function(list, index, event){
            list['action'] = 'loadTopicDetail';
            // this.lists[index].order = 'visited';
            function kkaction(opts){
                if(!opts){
                  return ;
                }
                var locat = ["kkaction://"];
                opts.action && locat.push(opts.action);
                opts.id && locat.push("?id=" + opts.id);
                locat = locat.join("");
                location.href = locat;
            }
            kkaction(list);
        }
    }
})



});
